#ifndef KMEM_INCLUDED
#define KMEM_INCLUDED

#define BYTE_OFFSET(virtaddr) ((ULONG)((LONG_PTR)(virtaddr) & (PAGE_SIZE - 1)))

typedef struct
{
	USHORT	Length;
	USHORT	MaxLen;
	WCHAR *	Buffer;

} UNICODE_STRING, *PUNICODE_STRING;

typedef struct
{
	ULONG	Length;
	HANDLE	RootDirectory;
	PUNICODE_STRING	ObjectName;
	ULONG	Attributes;
	PSECURITY_DESCRIPTOR SecurityDescriptor;
	PSECURITY_QUALITY_OF_SERVICE SecurityQualityOfService;

} OBJECT_ATTRIBUTES, *POBJECT_ATTRIBUTES;

#define	OBJ_CASE_INSENSITIVE	0x0040
#define PAGE_SIZE 0x1000

typedef VOID	 (NTAPI * RTLINITUNICODESTRING)(PUNICODE_STRING, PCWSTR);
typedef ULONG	 (NTAPI * ZWOPENSECTION)(PHANDLE, ACCESS_MASK, POBJECT_ATTRIBUTES);

#pragma pack(push, 1)
typedef struct _HARDWARE_PTE 
{
    ULONG Valid				: 1;
    ULONG Write				: 1;
    ULONG Owner				: 1;
    ULONG WriteThrough		: 1;
    ULONG CacheDisable		: 1;
    ULONG Accessed			: 1;
    ULONG Dirty				: 1;
    ULONG LargePage			: 1;
    ULONG Global			: 1;
    ULONG CopyOnWrite		: 1;
    ULONG Prototype			: 1;
    ULONG reserved			: 1;
    ULONG PageFrameNumber	: 20;

} HARDWARE_PTE, *PHARDWARE_PTE; 
#pragma pack(pop)
#endif